<html>
<head>
<title>Whitelist/Blacklist administration</title>
</head>
<body bgcolor="#ffffff">
<?php
//
// whitelist.php -- web front end for the whitelist module
//
// configuration: make sure the variable dbdir is set to a directory 
//                containing all your whitelist/blacklist databases
//                if they are not all in the same directory, set the
//                variables {white,black}list{,types} individually.
//
$bindir = "/usr/bin";

$dbdir = "/var/lib/mod_webfilter";

$whitelist = $dbdir."/white";
$blacklist = $dbdir."/black";

$whitelisttypes = $dbdir."/whitetypes";
$blacklisttypes = $dbdir."/blacktypes";

$filename = "whitelist.php";

// no configuration below this line
// ------------------------------------------------------------------------
// verify correctnes of input
if (!isset($HTTP_GET_VARS['db'])) {
	$db = "white";
} else {
	if ($HTTP_GET_VARS['db'] == 'black')  {
		$db = 'black';
	} else {
		$db = 'white';
	}
}

if (!isset($HTTP_GET_VARS['mode'])) {
	$mode = "host"; // host or type
} else {
	$t = $HTTP_GET_VARS['mode'];
	if (($t != 'host') && ($t != 'mode')) {
		$t = 'list';
	}
	$mode = $t;
}

if (!isset($HTTP_GET_VARS['action'])) {
	$action = "list"; // add, delete, list, update
} else {
	$a = $HTTP_GET_VARS['action'];
	if (($a != 'add') && ($a != 'delete') && ($a != 'list')
		&& ($a != 'update')) {
		$a = 'list';
	}
	$action = $a;
}

if (!isset($HTTP_GET_VARS['comment'])) {
	$comment = "";
} else {
	$comment = trim($HTTP_GET_VARS['comment']);
}

// find out which database file to use (depends on the values of db and type)
if ($db == 'black') {
	if ($mode == 'host') {
		$dbfile = $blacklist;
	} else {
		$dbfile = $blacklisttypes;
	}
} else {
	if ($mode == 'host') {
		$dbfile = $whitelist;
	} else {
		$dbfile = $whitelisttypes;
	}
}

// retrieve some variables that aren't always there
if (isset($HTTP_GET_VARS['host'])) {
	$host = $HTTP_GET_VARS['host'];
}
if (isset($HTTP_GET_VARS['categories'])) {
	$categories = $HTTP_GET_VARS['categories'];
}
if (isset($HTTP_GET_VARS['type'])) {
	$type = $HTTP_GET_VARS['type'];
}

// function to simplify formatting of hidden tags
function	put_hidden($name, $value) {
	printf("<input type=\"hidden\" name=\"%s\" value=\"%s\">\n",
		$name, $value);
}
function	get_button($name, $value) {
	return sprintf("<input type=\"submit\" name=\"%s\" value=\"%s\">",
		$name, $value);
}

function	get_textfield($name, $value) {
	return sprintf("<input type=\"text\" name=\"%s\" value=\"%s\">",
		$name, $value);
}

// open the file and read data from it, formatting every line as a table row
function	host_list($db, $dbfile) {
	global	$bindir, $filename;

	printf("<form action=\"%s\" method=\"GET\">\n", $filename);
	put_hidden('db', $db);
	put_hidden('mode', 'host');
	printf("<table>\n");
	printf("<tr>\n");
	printf("  <td>Host:</td>\n");
	printf("  <td>%s</td>\n", get_textfield('host', ''));
	printf("  <td>Categories:</td>\n");
	printf("  <td>%s</td>\n", get_textfield('categories', ''));
	printf("  <td>Comment:</td>\n");
	printf("  <td>%s</td>\n", get_textfield('comment', ''));
	printf("  <td>%s</td>\n", get_button('action', 'add'));
	printf("</tr>\n");
	printf("</table>\n");
	printf("</form>\n");

	$cmd = $bindir."/webfilter_dump ".$dbfile;
	$h = popen($cmd, "r");
	$count = 0;
	printf("<p>Currently %slisted hosts:</p>\n", $db);
	printf("<table border=\"1\">\n");
	printf("<tr>\n");
	printf("  <td>Host</td>\n");
	printf("  <td>Categories</td>\n");
	printf("  <td>Comment</td>\n");
	printf("  <td>&nbsp;</td><td>&nbsp;</td>\n");
	printf("</tr>\n");
	while ($l = chop(fgets($h, 1024))) {
		$count++;
		list($l, $comment) = split('#', chop($l));
		$sl = split(' ', $l);
		$host = array_shift($sl);
		$categories = join(' ', $sl);
		printf("<tr>\n");
		printf("  <form action=\"%s\" method=\"GET\">\n", $filename);
		put_hidden('mode', 'host');
		put_hidden('db', $db);
		put_hidden('host', $host);
		printf("  <td>%s</td>\n", $host);
		printf("  <td>%s</td>\n", get_textfield("categories",
			$categories));
		printf("  <td>%s</td>\n", get_textfield("comment", $comment));
		printf("  <td>%s</td>\n", get_button('action', 'update'));
		printf("  <td>%s</td>\n", get_button('action', 'delete'));
		printf("  </form>\n");
		printf("</tr>\n");
	}
	pclose($h);
	printf("</table>\n");
	printf("Entries found: %d\n", $count);
}

function	host_delete($dbfile, $hostname) {
	global	$bindir;
	$cmd = $bindir."/webfilter_delete ".$dbfile." ".$hostname;
	passthru($cmd);
	printf("host %s has been deleted<br />\n", $hostname);
}

function	host_add($dbfile, $hostname, $categories, $comment) {
	global	$bindir;
	if (strlen($comment) > 0) {
		$cmd = $bindir."/webfilter_add -c \"".$comment."\" ".
			$dbfile." ".$hostname." ".$categories;
	} else {
		$cmd = $bindir."/webfilter_add ".$dbfile." ".$hostname." ".
			$categories;
	}
	passthru($cmd);
	printf("host %s has been added with categories: <code>%s</code><br />\n",
		$hostname, $categories);
}

function	host_update($dbfile, $hostname, $categories, $comment) {
	global	$bindir;
	host_delete($dbfile, $hostname);
	host_add($dbfile, $hostname, $categories, $comment);
}

function	handle_host() {
	global	$db, $type, $action, $dbfile, $host, $categories, $comment;
	if ($action == 'add') {
		host_add($dbfile, $host, $categories, $comment);
	}
	if ($action == 'delete') {
		host_delete($dbfile, $host);
	}
	if ($action == 'update') {
		host_update($dbfile, $host, $categories, $comment);
	}
	host_list($db, $dbfile);
}

//
// functions to handle types
//
function	get_typelink($db, $action, $type, $comment) {
	global	$db;
	return sprintf("<a href=\"%s?db=%s&mode=type&action=%s&type=%s\">%s</a>",
		$filename, $db, 
		$action, urlencode($type), $type);
}

function	type_list($db, $dbfile) {
	global	$bindir, $filename;
	printf("<form action=\"%s\" method=\"GET\">\n", $filename);
	put_hidden('db', $db);
	put_hidden('mode', 'type');
	printf("<table>\n");
	printf("<tr>\n");
	printf("  <td>Add Type:<td>\n");
	printf("  <td>%s</td>\n", get_textfield('type', ''));
	printf("  <td>Comment:<td>\n");
	printf("  <td>%s</td>\n", get_textfield('comment', ''));
	printf("  <td><input type=\"submit\" name=\"action\" ".
		"value=\"add\"></td>\n");
	printf("</tr>\n");
	printf("</table>\n");
	printf("</form>\n");
	printf("<p>Current list of %slisted types:</p>\n", $db);
	printf("<table border=\"1\">\n");
	printf("<tr>\n");
	printf("  <td>Type</td>\n");
	printf("  <td>Comment</td>\n");
	printf("  <td>&nbsp;</td>\n");
	printf("  <td>&nbsp;</td>\n");
	printf("</tr>\n");
	$cmd = $bindir."/webfilter_types ".$dbfile." -l";
	$h = popen($cmd, "r");
	$count = 0;
	while ($l = chop(fgets($h, 1024))) {
		list($l, $comment) = split('#', $l);
		printf("<tr>\n");
		printf("<form action=\"%s\" method=\"GET\">\n", $filename);
		printf("  <td>%s</td>\n", $l);
		put_hidden("type", $l);
		put_hidden("mode", "type");
		put_hidden("db", $db);
		printf("  <td>%s</td>\n",
			get_textfield("comment", $comment));
		printf("  <td>%s</td>\n", get_button('action', 'update'));
		printf("  <td>%s</td>\n", get_button("action", 'delete'));
		$count++;
		printf("</form>\n");
		printf("</tr>\n");
	}
	pclose($h);
	printf("</table>\n");
	printf("Entries found: %d\n", $count);
}

function	type_add($dbfile, $type, $comment) {
	global	$bindir;
	if (strlen($comment) > 0) {
		$cmd = $bindir."/webfilter_types ".$dbfile.
			" -C \"".$comment."\" -a ".$type;
	} else {
		$cmd = $bindir."/webfilter_types ".$dbfile." -a ".$type;
	}
	passthru($cmd);
	printf("type %s added\n", $type);
}

function	type_delete($dbfile, $type) {
	global	$bindir;
	$cmd = $bindir."/webfilter_types ".$dbfile." -r ".$type;
	passthru($cmd);
	printf("type %s deleted\n", $type);
}

function	type_update($dbfile, $type, $comment) {
	type_delete($dbfile, $type);
	type_add($dbfile, $type, $comment);
	printf("type %s updated\n", $type);
}

function	handle_type() {
	global	$db, $type, $action, $dbfile, $hostname, $categories, $comment;
	if ($action == 'add') {
		type_add($dbfile, $type, $comment);
	}
	if ($action == 'delete') {
		type_delete($dbfile, $type);
	}
	if ($action == 'update') {
		type_update($dbfile, $type, $comment);
	}
	type_list($db, $dbfile);
}

// report action requested
function	action_requested() {
	global	$mode, $action, $db, $dbfile, $hostname, $type, $categories;
	$ar = "<p>Action requested: ";
	if ($mode == 'host') {
		if ($action == 'add') {
			printf("%sadding host %s requested, categories %s</p>",
				$ar, $host, $categories);
		}
		if ($action == 'delete') {
			printf("%sdeletion of host %s requested</p>",
				$ar, $host);
		}
		if ($action == 'update') {
			printf("%supdating host %s requested, categories %s</p>",
				$ar, $host, $categories);
		}
	} else {
		if ($action == 'add') {
			printf("%sadding type %s requested</p>",
				$ar, $type);
		}
		if( $action == 'delete') {
			printf("%sdeletion of type %s requested</p>",
				$ar, $type);
		}
	}
}

// header and footer for admin page
function	menu() {
	global	$filename;
	printf("<a href=\"%s?mode=host&db=white\">Whitelist</a> |\n",
		$filename);
	printf("<a href=\"%s?mode=host&db=black\">Blacklist</a> |\n",
		$filename);
	printf("<a href=\"%s?mode=type&db=white\">Whitelisted types</a> |\n",
		$filename);
	printf("<a href=\"%s?mode=type&db=black\">Blacklisted types</a>\n",
		$filename);
}

?>

<table>
<tr><td><? menu() ?></td></tr>
</table>
<h1>Whitelist Administration</h1>
<? action_requested() ?>
<?php
if ($mode == 'host') {
	handle_host();
} else {
	handle_type();
}
?>
<hr />
&copy; 2003 Dr. Andreas M&uuml;ller, Beratung und Entwicklung<br />
<i>$Id: whitelist.php.in,v 1.7 2003/03/16 23:54:28 afm Exp $</i>
</body>
</html>
